/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2023-2023. All rights reserved.
 * Description: the main header file of KML_IPL
 * Author: gm
 * Create: 2023-12-22
 * Notes: NA
 */
#ifndef CSPLINE_H_
#define CSPLINE_H_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#ifdef __cplusplus
extern "C"
{
#endif


void KIPL_Csint(int nData, float *xData, float *fData, float *coef);
float KIPL_Csval(float xi, int initv, float *xData, float *coef);
void KIPL_Cssmh(int nData, float *xData, float *fData, float *weight, float smpar, float *coef);
void KIPL_Cs1gd(int ideriv, int nVec, float *xVec, int initv, float *xData, float *coef, float *derValue);

void KIPL_Bsnak(int nData, float *xData, int k, float *xKnot);
void KIPL_Bsint(int nData, float *xData, float *fData, int k, float *xKnot, float *coef);
float KIPL_Bsval(float xi, int k, float *xKnot, int nData, float *coef);
float KIPL_Bsder(int ideriv, float xi, int k, float *xKnot, int ncoef, float *coef);

#ifdef __cplusplus
}
#endif

#endif